/*
Copyright (C) 2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*/

#include <fstream>

#include <vector>
#include <string>

extern "C"{
#include <mathlink.h>
}

#include <string.h>
#include <time.h>
#include <math.h>

using namespace std;

//ofstream out("info.txt");
string s;
bool global_error;

extern "C"{

int dotdriver_(char *outfile, char *postfile, long *method, long *iprint, long *ndv, long *ncon, double *x, double *xl, double *xu, long *minmax, double *g, double *prpm, long *iprm, double *wk, long *nrwk, long *iwk, long *nriwk, int, int);

int eval_(double *x, double *obj, double *g, int *ndv, int *ncon)
{
	if (global_error)
	{
		*obj = 0.;
		return 0;
	}
	else
	{
//out << x[0] << " " << x[1] << endl;
//out << *ndv << " " << *ncon << endl;
		MLPutFunction(stdlink, "EvaluatePacket", 1);
		MLPutFunction(stdlink, s.c_str(), 1);
		MLPutRealList(stdlink, x, *ndv);
		MLEndPacket(stdlink);
		long n; //number of arguments
		MLCheckFunction(stdlink, "ReturnPacket", &n);
//out << "ReturnPacket " << n << endl;		
		MLCheckFunction(stdlink, "List", &n);
//out << "List " << n << endl;		
		double res;
		int ret = MLGetReal(stdlink, obj);
//out << ret << endl;
//out << *obj << endl;
		if (ret != 1 )  {global_error = true; *obj=0.;}
		double *tmp;
		ret = MLGetRealList(stdlink, &tmp, &n);
//out << ret << endl;
//out << n << endl;
//out << tmp[0] << " " << tmp[1] << endl;
		if (ret != 1 )  
			global_error = true;
		else
			for (int i = 0; i < *ncon; ++i)
				g[i] = tmp[i];
		MLDisownRealList(stdlink, tmp, n);
//out << "end " << global_error << endl;
		return 0;
  }
}

void runDOT(char *str, char *outfile, char *postfile, long method, long iprint, double *x, long ndv, double *xl, long ndv2, double *xu, long ndv3, long minmax, long ncon, double *prpm, long len4, long *iprm, long len5, long nrwk, long nriwk)
{
//	out << str << endl;
//	out << len1 << endl;
//	out << outfile << endl;
//	out << len2 << endl;
//	out << postfile << endl;
//	out << len3 << endl;
//	out << method << endl;
//	out << iprint << endl;
//	out << ndv << endl;
//	out << ndv2 << endl;
//	out << ndv3 << endl;
//	out << len4 << endl;
//	out << len5 << endl;
//	out << nrwk << endl;
//	out << nriwk << endl;
	
	global_error = false;
	s = str;
	vector<double> wk(nrwk);
	vector<long> iwk(nriwk);
	vector<double> g(ncon);
//out << "started" << endl;
	dotdriver_(outfile, postfile, &method, &iprint, &ndv, &ncon, x, xl, xu, &minmax, &*g.begin(), prpm, iprm, &*wk.begin(), &nrwk, &*iwk.begin(), &nriwk, strlen(outfile), strlen(postfile));
//out << "finished" << endl;
	if (global_error)
	{
		MLClearError(stdlink);
		MLNewPacket(stdlink);
	}
	MLPutRealList(stdlink, x, ndv);
}

}

int main(int argc, char *argv[]) 
{
  return MLMain(argc, argv);
}


