(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     18207,        673]*)
(*NotebookOutlinePosition[     18842,        695]*)
(*  CellTagsIndexPosition[     18798,        691]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["http://Evgenii.Rudnyi.Ru/", "Text"],

Cell[BoxData[
    \(lnk\  = \ 
      Install["\<portNumber@serverName\>", \ LinkMode \[Rule] Connect, \ 
        LinkProtocol -> "\<TCP\>"]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(LinkPatterns[lnk]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      TagBox[\(runDOT[str_String, oufile_String, postfile_String, 
          method_Integer, iprint_Integer, x : {___Real}, xl : {___Real}, 
          xu : {___Real}, minmax_Integer, ncon_Integer, prpm : {___Real}, 
          iprm : {___Integer}, nrwk_Integer, nriwk_Integer]\),
        HoldForm], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(eval[
        X_]\  := \ \((Print[
          X]; {2.0*Sqrt[2. ]*X[\([1]\)] + 
            X[\([2]\)], \ {\((2. *X[\([1]\)] + Sqrt[2. ]*X[\([2]\)])\)/\((2. *
                    X[\([1]\)]*\((X[\([1]\)] + Sqrt[2.0]*X[\([2]\)])\))\) - 
              1. , 1. /\((2. *\((X[\([1]\)] + Sqrt[2. ]*X[\([2]\)])\))\) - 
              1. \ }})\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(eval[{1. , 1. }]\)], "Input"],

Cell[BoxData[
    \({3.8284271247461903`, {\(-0.2928932188134524`\), \(-0.7928932188134524`\
\)}}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(x\  = \ {1. , 1. };\)\), "\[IndentingNewLine]", 
    \(\(xl\  = \ {0.1, \ 0.1};\)\), "\[IndentingNewLine]", 
    \(\(xu\  = \ {100. , \ 100. };\)\), "\[IndentingNewLine]", 
    \(\(prpm\  = \ Table[0. , {20}];\)\), "\[IndentingNewLine]", 
    \(\(iprm\  = \ Table[0, {20}];\)\), "\[IndentingNewLine]", 
    \(\(method\  = \ 1;\)\), "\[IndentingNewLine]", 
    \(\(iprint\  = \ 3;\)\), "\[IndentingNewLine]", 
    \(\(minmax\  = \ \(-1\);\)\), "\[IndentingNewLine]", 
    \(\(ncon\  = \ 2;\)\), "\[IndentingNewLine]", 
    \(\(nrwk\  = \ 800;\)\), "\[IndentingNewLine]", 
    \(\(nriwk\  = \ 200;\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(runDOT["\<eval\>", \ "\<outfile\>", \ "\<postfile\>", \ method, \ 
      iprint, \ x, \ xl, \ xu, \ minmax, \ ncon, \ prpm, \ iprm, nrwk, \ 
      nriwk]\)\(\ \)\)\)], "Input"],

Cell[BoxData[
    \({1.`, 1.`}\)], "Print"],

Cell[BoxData[
    \({1.0000999999974738`, 1.`}\)], "Print"],

Cell[BoxData[
    \({1.`, 1.0000999999974738`}\)], "Print"],

Cell[BoxData[
    \({0.8796841412655297`, 0.9574619202022867`}\)], "Print"],

Cell[BoxData[
    \({0.6850090048152846`, 0.8886338656460944`}\)], "Print"],

Cell[BoxData[
    \({0.17534290083547133`, 0.7084396865135676`}\)], "Print"],

Cell[BoxData[
    \({0.6766915113056506`, 0.8856931876145258`}\)], "Print"],

Cell[BoxData[
    \({0.6767915113031244`, 0.8856931876145258`}\)], "Print"],

Cell[BoxData[
    \({0.6766915113056506`, 0.8857931876119995`}\)], "Print"],

Cell[BoxData[
    \({0.6751891558055074`, 0.8851620247335729`}\)], "Print"],

Cell[BoxData[
    \({0.6751925523430709`, 0.8851625509842476`}\)], "Print"],

Cell[BoxData[
    \({0.6727582936975236`, 0.8843025851932291`}\)], "Print"],

Cell[BoxData[
    \({0.6752846850204082`, 0.8846940176780287`}\)], "Print"],

Cell[BoxData[
    \({0.6752653974493712`, 0.8846910293120585`}\)], "Print"],

Cell[BoxData[
    \({0.6663942143267361`, 0.8820525433536789`}\)], "Print"],

Cell[BoxData[
    \({0.6756066000071012`, 0.8834798863726061`}\)], "Print"],

Cell[BoxData[
    \({0.6754561308197448`, 0.883456573069018`}\)], "Print"],

Cell[BoxData[
    \({0.6497328388811019`, 0.8761618575729182`}\)], "Print"],

Cell[BoxData[
    \({0.6770233232459755`, 0.8803901740690856`}\)], "Print"],

Cell[BoxData[
    \({0.6759571755954072`, 0.8802249879317501`}\)], "Print"],

Cell[BoxData[
    \({0.6759590066883447`, 0.8802252716365159`}\)], "Print"],

Cell[BoxData[
    \({0.6061127933777994`, 0.8607398425873686`}\)], "Print"],

Cell[BoxData[
    \({0.6850800525396807`, 0.8729748238397013`}\)], "Print"],

Cell[BoxData[
    \({0.6773584949555311`, 0.8717784658391379`}\)], "Print"],

Cell[BoxData[
    \({0.6772858944139689`, 0.8717672173005112`}\)], "Print"],

Cell[BoxData[
    \({0.49191403614321927`, 0.8203644847654812`}\)], "Print"],

Cell[BoxData[
    \({0.746061319009843`, 0.8597414021639949`}\)], "Print"],

Cell[BoxData[
    \({0.6863556814356327`, 0.8504907663418559`}\)], "Print"],

Cell[BoxData[
    \({0.6809054758549473`, 0.8496463256988758`}\)], "Print"],

Cell[BoxData[
    \({0.6808436865459289`, 0.8496367522244326`}\)], "Print"],

Cell[BoxData[
    \({0.19293781996904724`, 0.7146604298301893`}\)], "Print"],

Cell[BoxData[
    \({1.791422981465386`, 0.9623255532067936`}\)], "Print"],

Cell[BoxData[
    \({1.3435742174987566`, 0.8929370333421323`}\)], "Print"],

Cell[BoxData[
    \({0.9962894553536398`, 0.8391296377307955`}\)], "Print"],

Cell[BoxData[
    \({0.7819590574183042`, 0.8059218446735729`}\)], "Print"],

Cell[BoxData[
    \({0.7019961094381292`, 0.7935325939916782`}\)], "Print"],

Cell[BoxData[
    \({0.6911195417914787`, 0.791847406957724`}\)], "Print"],

Cell[BoxData[
    \({0.6907693783619502`, 0.7917931535488936`}\)], "Print"],

Cell[BoxData[
    \({0.6907631655593272`, 0.7917921909534531`}\)], "Print"],

Cell[BoxData[
    \({0.1`, 0.4379236321266603`}\)], "Print"],

Cell[BoxData[
    \({3.8395839709063626`, 1.0173250227937563`}\)], "Print"],

Cell[BoxData[
    \({3.222267455859491`, 0.9216796114104057`}\)], "Print"],

Cell[BoxData[
    \({2.637367904316558`, 0.8310567998353525`}\)], "Print"],

Cell[BoxData[
    \({2.096334890200872`, 0.7472305552011232`}\)], "Print"],

Cell[BoxData[
    \({1.6161228932380107`, 0.6728277603929432`}\)], "Print"],

Cell[BoxData[
    \({1.221156150849983`, 0.6116326430784867`}\)], "Print"],

Cell[BoxData[
    \({0.9416896809766796`, 0.5683328368569485`}\)], "Print"],

Cell[BoxData[
    \({0.7962690474368976`, 0.5458017430347075`}\)], "Print"],

Cell[BoxData[
    \({0.7538766072128895`, 0.5392335688713101`}\)], "Print"],

Cell[BoxData[
    \({0.7482629933410251`, 0.5383638101737301`}\)], "Print"],

Cell[BoxData[
    \({0.1`, 0.10000000000000009`}\)], "Print"],

Cell[BoxData[
    \({4.935520412629835`, 0.8492029256392943`}\)], "Print"],

Cell[BoxData[
    \({4.284621272046481`, 0.7483543098114199`}\)], "Print"],

Cell[BoxData[
    \({3.65561846468476`, 0.6508982547651261`}\)], "Print"],

Cell[BoxData[
    \({3.0550986578550896`, 0.5578552815608324`}\)], "Print"],

Cell[BoxData[
    \({2.492566753036064`, 0.4706980548526011`}\)], "Print"],

Cell[BoxData[
    \({1.9819497380423097`, 0.3915843858222044`}\)], "Print"],

Cell[BoxData[
    \({1.543451087703038`, 0.32364454818549515`}\)], "Print"],

Cell[BoxData[
    \({1.2039929423070568`, 0.2710497881678361`}\)], "Print"],

Cell[BoxData[
    \({0.9891664309763931`, 0.23776512859460042`}\)], "Print"],

Cell[BoxData[
    \({0.8957512483319198`, 0.22329162374627623`}\)], "Print"],

Cell[BoxData[
    \({0.1`, 0.3525738045131843`}\)], "Print"],

Cell[BoxData[
    \({3.951218306432786`, 0.9492715280754419`}\)], "Print"],

Cell[BoxData[
    \({3.3307519864725306`, 0.853138094130934`}\)], "Print"],

Cell[BoxData[
    \({2.7416029645357476`, 0.7618568806922109`}\)], "Print"],

Cell[BoxData[
    \({2.1946546948245764`, 0.6771141417781796`}\)], "Print"],

Cell[BoxData[
    \({1.7059657045151582`, 0.6013979437219692`}\)], "Print"],

Cell[BoxData[
    \({1.2986995252195142`, 0.5382971837199472`}\)], "Print"],

Cell[BoxData[
    \({1.0021860298678287`, 0.49235615581552794`}\)], "Print"],

Cell[BoxData[
    \({0.8375442093103983`, 0.4668469813899522`}\)], "Print"],

Cell[BoxData[
    \({0.7824385560830446`, 0.45830905514950754`}\)], "Print"],

Cell[BoxData[
    \({0.7733069050927281`, 0.4568942209529663`}\)], "Print"],

Cell[BoxData[
    \({0.7734069050902019`, 0.4568942209529663`}\)], "Print"],

Cell[BoxData[
    \({0.7733069050927281`, 0.45699422095044007`}\)], "Print"],

Cell[BoxData[
    \({0.7723320855431806`, 0.4565495701960071`}\)], "Print"],

Cell[BoxData[
    \({0.7723333691486339`, 0.45654998566906585`}\)], "Print"],

Cell[BoxData[
    \({0.7707547944793203`, 0.45599191359242686`}\)], "Print"],

Cell[BoxData[
    \({0.7723542301128773`, 0.45650961349248`}\)], "Print"],

Cell[BoxData[
    \({0.772347150844714`, 0.4565073220989761`}\)], "Print"],

Cell[BoxData[
    \({0.766625393026119`, 0.45453194970752675`}\)], "Print"],

Cell[BoxData[
    \({0.7724382248459387`, 0.456413427391911`}\)], "Print"],

Cell[BoxData[
    \({0.7723831757876931`, 0.4563956092994827`}\)], "Print"],

Cell[BoxData[
    \({0.7558144800929226`, 0.4507097147845865`}\)], "Print"],

Cell[BoxData[
    \({0.7728636821142132`, 0.4562281426582853`}\)], "Print"],

Cell[BoxData[
    \({0.7724771937411397`, 0.45610304541278573`}\)], "Print"],

Cell[BoxData[
    \({0.7275111436956968`, 0.4407029742362453`}\)], "Print"],

Cell[BoxData[
    \({0.7754659211759748`, 0.45622481393253866`}\)], "Print"],

Cell[BoxData[
    \({0.7727286229419288`, 0.45533881452596686`}\)], "Print"],

Cell[BoxData[
    \({0.7727259560111024`, 0.4553379513028441`}\)], "Print"],

Cell[BoxData[
    \({0.6534120499221532`, 0.41450498839272`}\)], "Print"],

Cell[BoxData[
    \({0.7941502612457203`, 0.4600586552032035`}\)], "Print"],

Cell[BoxData[
    \({0.7738445764163591`, 0.45348618002125896`}\)], "Print"],

Cell[BoxData[
    \({0.773376023406321`, 0.45333452037245714`}\)], "Print"],

Cell[BoxData[
    \({0.45941811150439854`, 0.3459177737105802`}\)], "Print"],

Cell[BoxData[
    \({0.9732357450133831`, 0.5122285222848016`}\)], "Print"],

Cell[BoxData[
    \({0.8131640424551941`, 0.46041705661711546`}\)], "Print"],

Cell[BoxData[
    \({0.7767151048836758`, 0.4486193881508613`}\)], "Print"],

Cell[BoxData[
    \({0.7750915576936107`, 0.44809388390399196`}\)], "Print"],

Cell[BoxData[
    \({0.1`, 0.1663541215294122`}\)], "Print"],

Cell[BoxData[
    \({4.684821544393362`, 1.6503536057821167`}\)], "Print"],

Cell[BoxData[
    \({3.998494259447466`, 1.4282055184407954`}\)], "Print"],

Cell[BoxData[
    \({3.337349691842963`, 1.2142084876203998`}\)], "Print"],

Cell[BoxData[
    \({2.71011424686477`, 1.0111870465806887`}\)], "Print"],

Cell[BoxData[
    \({2.130069266149966`, 0.8234400549280325`}\)], "Print"],

Cell[BoxData[
    \({1.6178487951873488`, 0.6576462705087138`}\)], "Print"],

Cell[BoxData[
    \({1.2048110989737233`, 0.5239556301592546`}\)], "Print"],

Cell[BoxData[
    \({0.9309322204577557`, 0.435307443849272`}\)], "Print"],

Cell[BoxData[
    \({0.8143753231678417`, 0.3975807027341575`}\)], "Print"],

Cell[BoxData[
    \({0.7953149829779085`, 0.39141131648048066`}\)], "Print"],

Cell[BoxData[
    \({0.2674309217624604`, 0.2780400518268438`}\)], "Print"],

Cell[BoxData[
    \({1.6254036254013857`, 0.7175840498465225`}\)], "Print"],

Cell[BoxData[
    \({1.2054375577477663`, 0.5816508577327016`}\)], "Print"],

Cell[BoxData[
    \({0.9226806204925517`, 0.4901290514873217`}\)], "Print"],

Cell[BoxData[
    \({0.7985610350866748`, 0.4499544451379808`}\)], "Print"],

Cell[BoxData[
    \({0.7773411663917487`, 0.4430860700236453`}\)], "Print"],

Cell[BoxData[
    \({0.7768016863543187`, 0.4429114529552253`}\)], "Print"],

Cell[BoxData[
    \({0.7769016863517925`, 0.4429114529552253`}\)], "Print"],

Cell[BoxData[
    \({0.7768016863543187`, 0.4430114529526991`}\)], "Print"],

Cell[BoxData[
    \({0.1`, 0.20362592198541069`}\)], "Print"],

Cell[BoxData[
    \({4.501546604507025`, 1.6638606219545897`}\)], "Print"],

Cell[BoxData[
    \({3.822447842265337`, 1.4385662728464772`}\)], "Print"],

Cell[BoxData[
    \({3.1701134073394033`, 1.2221511207523823`}\)], "Print"],

Cell[BoxData[
    \({2.5540810408197636`, 1.0177793581144492`}\)], "Print"],

Cell[BoxData[
    \({1.9889615684953346`, 0.8302981981350408`}\)], "Print"],

Cell[BoxData[
    \({1.4974839525805055`, 0.6672480856400176`}\)], "Print"],

Cell[BoxData[
    \({1.1135837628463399`, 0.5398873125425427`}\)], "Print"],

Cell[BoxData[
    \({0.8767009382770149`, 0.4613002722715966`}\)], "Print"],

Cell[BoxData[
    \({0.791241222534421`, 0.432948591921545`}\)], "Print"],

Cell[BoxData[
    \({0.7813915368659213`, 0.42968091033384925`}\)], "Print"],

Cell[BoxData[
    \({0.1`, 0.10000000000000003`}\)], "Print"],

Cell[BoxData[
    \({5.15262099503566`, 1.7762318261469852`}\)], "Print"],

Cell[BoxData[
    \({4.455426205598754`, 1.544934031155786`}\)], "Print"],

Cell[BoxData[
    \({3.779243590471845`, 1.3206071281728278`}\)], "Print"],

Cell[BoxData[
    \({3.1307961789801775`, 1.1054815151903936`}\)], "Print"],

Cell[BoxData[
    \({2.5201096451709146`, 0.9028832588049969`}\)], "Print"],

Cell[BoxData[
    \({1.9625779032654147`, 0.7179193656518414`}\)], "Print"],

Cell[BoxData[
    \({1.4820992783047924`, 0.5585182224167448`}\)], "Print"],

Cell[BoxData[
    \({1.113774971965687`, 0.43632482512141435`}\)], "Print"],

Cell[BoxData[
    \({0.8955619571399354`, 0.3639315859115481`}\)], "Print"],

Cell[BoxData[
    \({0.8230388140728453`, 0.3398716770720153`}\)], "Print"],

Cell[BoxData[
    \({0.32207074565317306`, 0.2821397870626665`}\)], "Print"],

Cell[BoxData[
    \({1.3589338067504912`, 0.6261241991282391`}\)], "Print"],

Cell[BoxData[
    \({1.0183051405029742`, 0.5131189664335478`}\)], "Print"],

Cell[BoxData[
    \({0.8333093451189193`, 0.4517457028875969`}\)], "Print"],

Cell[BoxData[
    \({0.7830841249962718`, 0.43508323947948896`}\)], "Print"],

Cell[BoxData[
    \({0.7798020739503323`, 0.4339944029283904`}\)], "Print"],

Cell[BoxData[
    \({0.7797861925417758`, 0.4339891341931157`}\)], "Print"],

Cell[BoxData[
    \({0.20536943986910838`, 0.24087964471604803`}\)], "Print"],

Cell[BoxData[
    \({2.16143540397654`, 0.8898141336280988`}\)], "Print"],

Cell[BoxData[
    \({1.6433907987331449`, 0.7179502919653418`}\)], "Print"],

Cell[BoxData[
    \({1.220867072871352`, 0.5777759710955171`}\)], "Print"],

Cell[BoxData[
    \({0.9336487878398415`, 0.4824898946424829`}\)], "Print"],

Cell[BoxData[
    \({0.804601288256174`, 0.4396777529640615`}\)], "Print"],

Cell[BoxData[
    \({0.7812640546801057`, 0.4319355111270294`}\)], "Print"],

Cell[BoxData[
    \({0.7805605601000061`, 0.4317021233455505`}\)], "Print"],

Cell[BoxData[
    \({0.7805591959115409`, 0.4317016707693283`}\)], "Print"],

Cell[BoxData[
    \({0.7806591959090147`, 0.4317016707693283`}\)], "Print"],

Cell[BoxData[
    \({0.7805591959115409`, 0.4318016707668021`}\)], "Print"],

Cell[BoxData[
    \({0.1`, 0.19108765955537113`}\)], "Print"],

Cell[BoxData[
    \({4.548922168281277`, 1.6977188950753421`}\)], "Print"],

Cell[BoxData[
    \({3.8686390848690264`, 1.467340456501603`}\)], "Print"],

Cell[BoxData[
    \({3.214553257109827`, 1.2458337405966013`}\)], "Print"],

Cell[BoxData[
    \({2.5959310505248356`, 1.0363368098406058`}\)], "Print"],

Cell[BoxData[
    \({2.0269486099437195`, 0.8436504276076997`}\)], "Print"],

Cell[BoxData[
    \({1.5296729686720156`, 0.6752476132935508`}\)], "Print"],

Cell[BoxData[
    \({1.1372928452951303`, 0.5423677543714112`}\)], "Print"],

Cell[BoxData[
    \({0.8896738089845375`, 0.4585113593832698`}\)], "Print"],

Cell[BoxData[
    \({0.7957797777253404`, 0.4267140666968379`}\)], "Print"],

Cell[BoxData[
    \({0.7838479235857821`, 0.42267333425326015`}\)], "Print"],

Cell[BoxData[
    \({0.6444473547010082`, 0.3835788678094512`}\)], "Print"],

Cell[BoxData[
    \({0.808353041242012`, 0.4390856664634322`}\)], "Print"],

Cell[BoxData[
    \({0.7820442244539423`, 0.4301761635224556`}\)], "Print"],

Cell[BoxData[
    \({0.7811773325862214`, 0.4298825898620669`}\)], "Print"],

Cell[BoxData[
    \({0.3754895883166276`, 0.2884879375778599`}\)], "Print"],

Cell[BoxData[
    \({1.1818603349787506`, 0.5615660693987322`}\)], "Print"],

Cell[BoxData[
    \({0.9125324663323813`, 0.4703579600747156`}\)], "Print"],

Cell[BoxData[
    \({0.80014606745409`, 0.4322982115349801`}\)], "Print"],

Cell[BoxData[
    \({0.7827818335773491`, 0.42641779912271294`}\)], "Print"],

Cell[BoxData[
    \({0.7824016708676178`, 0.4262890567012014`}\)], "Print"],

Cell[BoxData[
    \({0.39816177635133243`, 0.296503766529698`}\)], "Print"],

Cell[BoxData[
    \({1.1194092831989046`, 0.5407548415664313`}\)], "Print"],

Cell[BoxData[
    \({0.8799669089719913`, 0.4596674800726031`}\)], "Print"],

Cell[BoxData[
    \({0.7926537225893789`, 0.4300987960406141`}\)], "Print"],

Cell[BoxData[
    \({0.7824300518389714`, 0.4266365413390025`}\)], "Print"],

Cell[BoxData[
    \({0.782297866966305`, 0.42659177682065635`}\)], "Print"],

Cell[BoxData[
    \({0.7824016708676178`, 0.4262890567012014`}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Uninstall[lnk]\)], "Input"]
},
FrontEndVersion->"5.1 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 705}},
WindowSize->{681, 610},
WindowMargins->{{7, Automatic}, {Automatic, 0}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 41, 0, 36, "Text"],
Cell[1798, 53, 152, 3, 52, "Input"],

Cell[CellGroupData[{
Cell[1975, 60, 50, 1, 33, "Input"],
Cell[2028, 63, 347, 6, 90, "Output"]
}, Open  ]],
Cell[2390, 72, 367, 7, 109, "Input"],

Cell[CellGroupData[{
Cell[2782, 83, 49, 1, 33, "Input"],
Cell[2834, 86, 111, 2, 33, "Output"]
}, Open  ]],
Cell[2960, 91, 634, 11, 223, "Input"],

Cell[CellGroupData[{
Cell[3619, 106, 200, 3, 52, "Input"],
Cell[3822, 111, 43, 1, 28, "Print"],
Cell[3868, 114, 59, 1, 28, "Print"],
Cell[3930, 117, 59, 1, 28, "Print"],
Cell[3992, 120, 75, 1, 28, "Print"],
Cell[4070, 123, 75, 1, 28, "Print"],
Cell[4148, 126, 76, 1, 28, "Print"],
Cell[4227, 129, 75, 1, 28, "Print"],
Cell[4305, 132, 75, 1, 28, "Print"],
Cell[4383, 135, 75, 1, 28, "Print"],
Cell[4461, 138, 75, 1, 28, "Print"],
Cell[4539, 141, 75, 1, 28, "Print"],
Cell[4617, 144, 75, 1, 28, "Print"],
Cell[4695, 147, 75, 1, 28, "Print"],
Cell[4773, 150, 75, 1, 28, "Print"],
Cell[4851, 153, 75, 1, 28, "Print"],
Cell[4929, 156, 75, 1, 28, "Print"],
Cell[5007, 159, 74, 1, 28, "Print"],
Cell[5084, 162, 75, 1, 28, "Print"],
Cell[5162, 165, 75, 1, 28, "Print"],
Cell[5240, 168, 75, 1, 28, "Print"],
Cell[5318, 171, 75, 1, 28, "Print"],
Cell[5396, 174, 75, 1, 28, "Print"],
Cell[5474, 177, 75, 1, 28, "Print"],
Cell[5552, 180, 75, 1, 28, "Print"],
Cell[5630, 183, 75, 1, 28, "Print"],
Cell[5708, 186, 76, 1, 28, "Print"],
Cell[5787, 189, 74, 1, 28, "Print"],
Cell[5864, 192, 75, 1, 28, "Print"],
Cell[5942, 195, 75, 1, 28, "Print"],
Cell[6020, 198, 75, 1, 28, "Print"],
Cell[6098, 201, 76, 1, 28, "Print"],
Cell[6177, 204, 74, 1, 28, "Print"],
Cell[6254, 207, 75, 1, 28, "Print"],
Cell[6332, 210, 75, 1, 28, "Print"],
Cell[6410, 213, 75, 1, 28, "Print"],
Cell[6488, 216, 75, 1, 28, "Print"],
Cell[6566, 219, 74, 1, 28, "Print"],
Cell[6643, 222, 75, 1, 28, "Print"],
Cell[6721, 225, 75, 1, 28, "Print"],
Cell[6799, 228, 60, 1, 28, "Print"],
Cell[6862, 231, 75, 1, 28, "Print"],
Cell[6940, 234, 74, 1, 28, "Print"],
Cell[7017, 237, 74, 1, 28, "Print"],
Cell[7094, 240, 74, 1, 28, "Print"],
Cell[7171, 243, 75, 1, 28, "Print"],
Cell[7249, 246, 74, 1, 28, "Print"],
Cell[7326, 249, 75, 1, 28, "Print"],
Cell[7404, 252, 75, 1, 28, "Print"],
Cell[7482, 255, 75, 1, 28, "Print"],
Cell[7560, 258, 75, 1, 28, "Print"],
Cell[7638, 261, 61, 1, 28, "Print"],
Cell[7702, 264, 74, 1, 28, "Print"],
Cell[7779, 267, 74, 1, 28, "Print"],
Cell[7856, 270, 73, 1, 28, "Print"],
Cell[7932, 273, 75, 1, 28, "Print"],
Cell[8010, 276, 74, 1, 28, "Print"],
Cell[8087, 279, 75, 1, 28, "Print"],
Cell[8165, 282, 75, 1, 28, "Print"],
Cell[8243, 285, 75, 1, 28, "Print"],
Cell[8321, 288, 76, 1, 28, "Print"],
Cell[8400, 291, 76, 1, 28, "Print"],
Cell[8479, 294, 60, 1, 28, "Print"],
Cell[8542, 297, 74, 1, 28, "Print"],
Cell[8619, 300, 74, 1, 28, "Print"],
Cell[8696, 303, 75, 1, 28, "Print"],
Cell[8774, 306, 75, 1, 28, "Print"],
Cell[8852, 309, 75, 1, 28, "Print"],
Cell[8930, 312, 75, 1, 28, "Print"],
Cell[9008, 315, 76, 1, 28, "Print"],
Cell[9087, 318, 75, 1, 28, "Print"],
Cell[9165, 321, 76, 1, 28, "Print"],
Cell[9244, 324, 75, 1, 28, "Print"],
Cell[9322, 327, 75, 1, 28, "Print"],
Cell[9400, 330, 76, 1, 28, "Print"],
Cell[9479, 333, 75, 1, 28, "Print"],
Cell[9557, 336, 76, 1, 28, "Print"],
Cell[9636, 339, 76, 1, 28, "Print"],
Cell[9715, 342, 73, 1, 28, "Print"],
Cell[9791, 345, 74, 1, 28, "Print"],
Cell[9868, 348, 75, 1, 28, "Print"],
Cell[9946, 351, 74, 1, 28, "Print"],
Cell[10023, 354, 75, 1, 28, "Print"],
Cell[10101, 357, 75, 1, 28, "Print"],
Cell[10179, 360, 75, 1, 28, "Print"],
Cell[10257, 363, 76, 1, 28, "Print"],
Cell[10336, 366, 75, 1, 28, "Print"],
Cell[10414, 369, 76, 1, 28, "Print"],
Cell[10493, 372, 76, 1, 28, "Print"],
Cell[10572, 375, 75, 1, 28, "Print"],
Cell[10650, 378, 73, 1, 28, "Print"],
Cell[10726, 381, 75, 1, 28, "Print"],
Cell[10804, 384, 76, 1, 28, "Print"],
Cell[10883, 387, 75, 1, 28, "Print"],
Cell[10961, 390, 76, 1, 28, "Print"],
Cell[11040, 393, 75, 1, 28, "Print"],
Cell[11118, 396, 76, 1, 28, "Print"],
Cell[11197, 399, 75, 1, 28, "Print"],
Cell[11275, 402, 76, 1, 28, "Print"],
Cell[11354, 405, 60, 1, 28, "Print"],
Cell[11417, 408, 74, 1, 28, "Print"],
Cell[11494, 411, 74, 1, 28, "Print"],
Cell[11571, 414, 74, 1, 28, "Print"],
Cell[11648, 417, 73, 1, 28, "Print"],
Cell[11724, 420, 74, 1, 28, "Print"],
Cell[11801, 423, 75, 1, 28, "Print"],
Cell[11879, 426, 75, 1, 28, "Print"],
Cell[11957, 429, 74, 1, 28, "Print"],
Cell[12034, 432, 75, 1, 28, "Print"],
Cell[12112, 435, 76, 1, 28, "Print"],
Cell[12191, 438, 75, 1, 28, "Print"],
Cell[12269, 441, 75, 1, 28, "Print"],
Cell[12347, 444, 75, 1, 28, "Print"],
Cell[12425, 447, 75, 1, 28, "Print"],
Cell[12503, 450, 75, 1, 28, "Print"],
Cell[12581, 453, 75, 1, 28, "Print"],
Cell[12659, 456, 75, 1, 28, "Print"],
Cell[12737, 459, 75, 1, 28, "Print"],
Cell[12815, 462, 75, 1, 28, "Print"],
Cell[12893, 465, 61, 1, 28, "Print"],
Cell[12957, 468, 74, 1, 28, "Print"],
Cell[13034, 471, 74, 1, 28, "Print"],
Cell[13111, 474, 75, 1, 28, "Print"],
Cell[13189, 477, 75, 1, 28, "Print"],
Cell[13267, 480, 75, 1, 28, "Print"],
Cell[13345, 483, 75, 1, 28, "Print"],
Cell[13423, 486, 75, 1, 28, "Print"],
Cell[13501, 489, 75, 1, 28, "Print"],
Cell[13579, 492, 73, 1, 28, "Print"],
Cell[13655, 495, 76, 1, 28, "Print"],
Cell[13734, 498, 61, 1, 28, "Print"],
Cell[13798, 501, 73, 1, 28, "Print"],
Cell[13874, 504, 73, 1, 28, "Print"],
Cell[13950, 507, 74, 1, 28, "Print"],
Cell[14027, 510, 75, 1, 28, "Print"],
Cell[14105, 513, 75, 1, 28, "Print"],
Cell[14183, 516, 75, 1, 28, "Print"],
Cell[14261, 519, 75, 1, 28, "Print"],
Cell[14339, 522, 75, 1, 28, "Print"],
Cell[14417, 525, 75, 1, 28, "Print"],
Cell[14495, 528, 75, 1, 28, "Print"],
Cell[14573, 531, 76, 1, 28, "Print"],
Cell[14652, 534, 75, 1, 28, "Print"],
Cell[14730, 537, 75, 1, 28, "Print"],
Cell[14808, 540, 75, 1, 28, "Print"],
Cell[14886, 543, 76, 1, 28, "Print"],
Cell[14965, 546, 75, 1, 28, "Print"],
Cell[15043, 549, 75, 1, 28, "Print"],
Cell[15121, 552, 77, 1, 28, "Print"],
Cell[15201, 555, 73, 1, 28, "Print"],
Cell[15277, 558, 75, 1, 28, "Print"],
Cell[15355, 561, 74, 1, 28, "Print"],
Cell[15432, 564, 75, 1, 28, "Print"],
Cell[15510, 567, 74, 1, 28, "Print"],
Cell[15587, 570, 75, 1, 28, "Print"],
Cell[15665, 573, 75, 1, 28, "Print"],
Cell[15743, 576, 75, 1, 28, "Print"],
Cell[15821, 579, 75, 1, 28, "Print"],
Cell[15899, 582, 75, 1, 28, "Print"],
Cell[15977, 585, 61, 1, 28, "Print"],
Cell[16041, 588, 74, 1, 28, "Print"],
Cell[16118, 591, 74, 1, 28, "Print"],
Cell[16195, 594, 74, 1, 28, "Print"],
Cell[16272, 597, 75, 1, 28, "Print"],
Cell[16350, 600, 75, 1, 28, "Print"],
Cell[16428, 603, 75, 1, 28, "Print"],
Cell[16506, 606, 75, 1, 28, "Print"],
Cell[16584, 609, 75, 1, 28, "Print"],
Cell[16662, 612, 75, 1, 28, "Print"],
Cell[16740, 615, 76, 1, 28, "Print"],
Cell[16819, 618, 75, 1, 28, "Print"],
Cell[16897, 621, 74, 1, 28, "Print"],
Cell[16974, 624, 75, 1, 28, "Print"],
Cell[17052, 627, 75, 1, 28, "Print"],
Cell[17130, 630, 75, 1, 28, "Print"],
Cell[17208, 633, 75, 1, 28, "Print"],
Cell[17286, 636, 75, 1, 28, "Print"],
Cell[17364, 639, 73, 1, 28, "Print"],
Cell[17440, 642, 76, 1, 28, "Print"],
Cell[17519, 645, 75, 1, 28, "Print"],
Cell[17597, 648, 75, 1, 28, "Print"],
Cell[17675, 651, 75, 1, 28, "Print"],
Cell[17753, 654, 75, 1, 28, "Print"],
Cell[17831, 657, 75, 1, 28, "Print"],
Cell[17909, 660, 75, 1, 28, "Print"],
Cell[17987, 663, 75, 1, 28, "Print"],
Cell[18065, 666, 76, 1, 33, "Output"]
}, Open  ]],
Cell[18156, 670, 47, 1, 33, "Input"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

